Package icyllis.modernui.text

# Interface Spanned

All Superinterfaces:
  `CharSequence`

All Known Subinterfaces:
  `Editable`, `Spannable`

All Known Implementing Classes:
  `PrecomputedText`, `SpannableString`, `SpannableStringBuilder`, `SpannedString`

public interface Spanned extends CharSequence
This is the interface for text that has markup objects attached to ranges of it.
Not all text classes have mutable markup or text; see `Spannable` for mutable markup and `Editable` for mutable text.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `SPAN_COMPOSING`
  This flag is set on spans that are being used to apply temporary styling information on the composing text of an input method, so that they can be found and removed when the composing text is being replaced.
  `static final int`
  `SPAN_EXCLUSIVE_EXCLUSIVE`
  Spans of type SPAN_EXCLUSIVE_EXCLUSIVE do not expand to include text inserted at either their starting or ending point.
  `static final int`
  `SPAN_EXCLUSIVE_INCLUSIVE`
  Non-0-length spans of type SPAN_EXCLUSIVE_INCLUSIVE expand to include text inserted at their ending point but not at their starting point.
  `static final int`
  `SPAN_INCLUSIVE_EXCLUSIVE`
  Non-0-length spans of type SPAN_INCLUSIVE_EXCLUSIVE expand to include text inserted at their starting point but not at their ending point.
  `static final int`
  `SPAN_INCLUSIVE_INCLUSIVE`
  Spans of type SPAN_INCLUSIVE_INCLUSIVE expand to include text inserted at either their starting or ending point.
  `static final int`
  `SPAN_INTERMEDIATE`
  This flag will be set for intermediate span changes, meaning there is guaranteed to be another change following it.
  `static final int`
  `SPAN_MARK_MARK`
  0-length spans with type SPAN_MARK_MARK behave like text marks: they remain at their original offset when text is inserted at that offset.
  `static final int`
  `SPAN_MARK_POINT`
  SPAN_MARK_POINT is a synonym for `SPAN_INCLUSIVE_INCLUSIVE`.
  `static final int`
  `SPAN_PARAGRAPH`
  SPAN_PARAGRAPH behaves like SPAN_INCLUSIVE_EXCLUSIVE (SPAN_MARK_MARK), except that if either end of the span is at the end of the buffer, that end behaves like _POINT instead (so SPAN_INCLUSIVE_INCLUSIVE if it starts in the middle and ends at the end, or SPAN_EXCLUSIVE_INCLUSIVE if it both starts and ends at the end).
  `static final int`
  `SPAN_POINT_MARK`
  SPAN_POINT_MARK is a synonym for `SPAN_EXCLUSIVE_EXCLUSIVE`.
  `static final int`
  `SPAN_POINT_MARK_MASK`
  Bitmask of bits that are relevant for controlling point/mark behavior of spans.
  `static final int`
  `SPAN_POINT_POINT`
  0-length spans with type SPAN_POINT_POINT behave like cursors: they are pushed forward by the length of the insertion when text is inserted at their offset.
  `static final int`
  `SPAN_PRIORITY`
  The bits specified by the SPAN_PRIORITY bitmap determine the order of change notifications -- higher numbers go first.
  `static final int`
  `SPAN_PRIORITY_SHIFT`
  The bits numbered just above SPAN_PRIORITY_SHIFT determine the order of change notifications -- higher numbers go first.
  `static final int`
  `SPAN_USER`
  The bits specified by the SPAN_USER bitfield are available for callers to use to store scalar data associated with their span object.
  `static final int`
  `SPAN_USER_SHIFT`
  The bits numbered SPAN_USER_SHIFT and above are available for callers to use to store scalar data associated with their span object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getSpanEnd(Object span)`
  Return the end of the range of text to which the specified markup object is attached, or `-1` if the object is not attached.
  `int`
  `getSpanFlags(Object span)`
  Return the flags that were specified when `Spannable.setSpan(java.lang.Object, int, int, int)` was used to attach the specified markup object, or `0` if the specified object has not been attached.
  `default <T> List<T>`
  `getSpans(int start, int end, Class<? extends T> type)`
  Convenience for getSpans(start, end, type, null).
  `<T> List<T>`
  `getSpans(int start, int end, Class<? extends T> type, List<T> dest)`
  Query a set of the markup objects attached to the specified slice of this `CharSequence` and whose type is the specified type or a subclass of it.
  `int`
  `getSpanStart(Object span)`
  Return the beginning of the range of text to which the specified markup object is attached, or `-1` if the object is not attached.
  `int`
  `nextSpanTransition(int start, int limit, Class<?> type)`
  Return the first offset greater than `start` where a markup object of class `type` begins or ends, or `limit` if there are no starts or ends greater than `start` but less than `limit`.

  ### Methods inherited from interface java.lang.CharSequence

  `charAt, chars, codePoints, isEmpty, length, subSequence, toString`

- ## Field Details

  - ### SPAN_POINT_MARK_MASK

    static final int SPAN_POINT_MARK_MASK
    Bitmask of bits that are relevant for controlling point/mark behavior of spans.

    MARK and POINT are conceptually located between two adjacent characters. A MARK is "attached" to the character before, while a POINT will stick to the character after. The insertion cursor is conceptually located between the MARK and the POINT.

    As a result, inserting a new character between a MARK and a POINT will leave the MARK unchanged, while the POINT will be shifted, now located after the inserted character and still glued to the same character after it.

    Depending on whether the insertion happens at the beginning or the end of a span, the span will hence be expanded to include the new character (when the span is using a MARK at its beginning or a POINT at its end) or it will be excluded.

    Note that before and after here refer to offsets in the String, which are independent of the visual representation of the text (left-to-right or right-to-left).

    See Also:
      - Constant Field Values

  - ### SPAN_MARK_MARK

    static final int SPAN_MARK_MARK
    0-length spans with type SPAN_MARK_MARK behave like text marks: they remain at their original offset when text is inserted at that offset. Conceptually, the text is added after the mark.
    See Also:
      - Constant Field Values

  - ### SPAN_MARK_POINT

    static final int SPAN_MARK_POINT
    SPAN_MARK_POINT is a synonym for `SPAN_INCLUSIVE_INCLUSIVE`.
    See Also:
      - Constant Field Values

  - ### SPAN_POINT_MARK

    static final int SPAN_POINT_MARK
    SPAN_POINT_MARK is a synonym for `SPAN_EXCLUSIVE_EXCLUSIVE`.
    See Also:
      - Constant Field Values

  - ### SPAN_POINT_POINT

    static final int SPAN_POINT_POINT
    0-length spans with type SPAN_POINT_POINT behave like cursors: they are pushed forward by the length of the insertion when text is inserted at their offset. The text is conceptually inserted before the point.
    See Also:
      - Constant Field Values

  - ### SPAN_PARAGRAPH

    static final int SPAN_PARAGRAPH
    SPAN_PARAGRAPH behaves like SPAN_INCLUSIVE_EXCLUSIVE (SPAN_MARK_MARK), except that if either end of the span is at the end of the buffer, that end behaves like _POINT instead (so SPAN_INCLUSIVE_INCLUSIVE if it starts in the middle and ends at the end, or SPAN_EXCLUSIVE_INCLUSIVE if it both starts and ends at the end).

    Its endpoints must be the start or end of the buffer or immediately after a \n character, and if the \n that anchors it is deleted, the endpoint is pulled to the next \n that follows in the buffer (or to the end of the buffer). If a span with SPAN_PARAGRAPH flag is pasted into another text and the paragraph boundary constraint is not satisfied, the span is discarded.

    See Also:
      - Constant Field Values

  - ### SPAN_INCLUSIVE_EXCLUSIVE

    static final int SPAN_INCLUSIVE_EXCLUSIVE
    Non-0-length spans of type SPAN_INCLUSIVE_EXCLUSIVE expand to include text inserted at their starting point but not at their ending point. When 0-length, they behave like marks.
    See Also:
      - Constant Field Values

  - ### SPAN_INCLUSIVE_INCLUSIVE

    static final int SPAN_INCLUSIVE_INCLUSIVE
    Spans of type SPAN_INCLUSIVE_INCLUSIVE expand to include text inserted at either their starting or ending point.
    See Also:
      - Constant Field Values

  - ### SPAN_EXCLUSIVE_EXCLUSIVE

    static final int SPAN_EXCLUSIVE_EXCLUSIVE
    Spans of type SPAN_EXCLUSIVE_EXCLUSIVE do not expand to include text inserted at either their starting or ending point. They can never have a length of 0 and are automatically removed from the buffer if all the text they cover is removed.
    See Also:
      - Constant Field Values

  - ### SPAN_EXCLUSIVE_INCLUSIVE

    static final int SPAN_EXCLUSIVE_INCLUSIVE
    Non-0-length spans of type SPAN_EXCLUSIVE_INCLUSIVE expand to include text inserted at their ending point but not at their starting point. When 0-length, they behave like points.
    See Also:
      - Constant Field Values

  - ### SPAN_COMPOSING

    static final int SPAN_COMPOSING
    This flag is set on spans that are being used to apply temporary styling information on the composing text of an input method, so that they can be found and removed when the composing text is being replaced.
    See Also:
      - Constant Field Values

  - ### SPAN_INTERMEDIATE

    static final int SPAN_INTERMEDIATE
    This flag will be set for intermediate span changes, meaning there is guaranteed to be another change following it. Typically it is used for `Selection` which automatically uses this with the first offset it sets when updating the selection.
    See Also:
      - Constant Field Values

  - ### SPAN_USER_SHIFT

    static final int SPAN_USER_SHIFT
    The bits numbered SPAN_USER_SHIFT and above are available for callers to use to store scalar data associated with their span object.
    See Also:
      - Constant Field Values

  - ### SPAN_USER

    static final int SPAN_USER
    The bits specified by the SPAN_USER bitfield are available for callers to use to store scalar data associated with their span object.
    See Also:
      - Constant Field Values

  - ### SPAN_PRIORITY_SHIFT

    static final int SPAN_PRIORITY_SHIFT
    The bits numbered just above SPAN_PRIORITY_SHIFT determine the order of change notifications -- higher numbers go first. You probably don't need to set this; it is used so that when text changes, the text layout gets the chance to update itself before any other callbacks can inquire about the layout of the text.
    See Also:
      - Constant Field Values

  - ### SPAN_PRIORITY

    static final int SPAN_PRIORITY
    The bits specified by the SPAN_PRIORITY bitmap determine the order of change notifications -- higher numbers go first. You probably don't need to set this; it is used so that when text changes, the text layout gets the chance to update itself before any other callbacks can inquire about the layout of the text.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getSpans

    @NonNull <T> List<T> getSpans(int start, int end, @Nullable Class<? extends T> type, @Nullable List<T> dest)
    Query a set of the markup objects attached to the specified slice of this `CharSequence` and whose type is the specified type or a subclass of it.
    Specify `null` or `Object.class` for the type if you want all the objects regardless of type.

    If `dest` list is non-null, it will be filled with the method results and returned as-is. Otherwise, a new (and possibly- unmodifiable) list will be created with method results and returned. The return list can be empty if there is no match.

    Parameters:
      `start` - start char index of the slice
      `end` - end char index of the slice
      `type` - markup class
      `dest` - the list that receives method results
    Returns:
      the list of results

  - ### getSpans

    @NonNull default <T> List<T> getSpans(int start, int end, @Nullable Class<? extends T> type)
    Convenience for getSpans(start, end, type, null).
    See Also:
      - `getSpans(int, int, Class, List)`

  - ### getSpanStart

    int getSpanStart(@NonNull Object span)
    Return the beginning of the range of text to which the specified markup object is attached, or `-1` if the object is not attached.
    Parameters:
      `span` - markup object
    Returns:
      the start char index

  - ### getSpanEnd

    int getSpanEnd(@NonNull Object span)
    Return the end of the range of text to which the specified markup object is attached, or `-1` if the object is not attached.
    Parameters:
      `span` - markup object
    Returns:
      the end char index

  - ### getSpanFlags

    int getSpanFlags(@NonNull Object span)
    Return the flags that were specified when `Spannable.setSpan(java.lang.Object, int, int, int)` was used to attach the specified markup object, or `0` if the specified object has not been attached.
    Parameters:
      `span` - markup object
    Returns:
      the flags

  - ### nextSpanTransition

    int nextSpanTransition(int start, int limit, @Nullable Class<?> type)
    Return the first offset greater than `start` where a markup object of class `type` begins or ends, or `limit` if there are no starts or ends greater than `start` but less than `limit`. Specify `null` or `Object.class` for the type if you want every transition regardless of type.
    Parameters:
      `start` - start char index of the slice
      `limit` - end char index of the slice
      `type` - the markup type
    Returns:
      transition point